﻿# Créé par apatura, le 03/03/2014 en Python 3.2
class Fraction : #définition de la classe Fraction
    def __init__(self,n=0,d=1):
        self.numerateur=n
        self.denominateur=d
    def affiche(self):
        print(self.numerateur,"/",self.denominateur)
    def mult(self,x):
        self.numerateur=self.numerateur*x
        self.denominateur=self.denominateur*x
#corps du programme
fr1=Fraction(3,7)
fr2=Fraction()
fr1.affiche()
fr2.affiche()
fr1.mult(4)
fr1.affiche()
print(fr1.numerateur)


"""
COMMENTAIRES:
Une classe comporte des attributs et des méthodes dont une _init_ est appelée constructeur.
C'est cette méthode qui permettra de créer ou construire des objets de la classe Fraction.
Dans le corps de cette méthode apparaissent les attributs ici il y en a 2:
numerateur
denominateur

fr1 et fr2 sont des objets qui sont des instances de la classe Fraction.
On peut les voir comme des variables de type Fraction ( nouveau type crée ) qui sont initialisées.
Pour fr1 le numerateur vaut 3 et le denominateur vaut 7.
Pour fr2 les valeurs des attributs sont celles par défaut soit 0 et 1.
En mémoire le contenu de la case réservée à fr1 ou fr2 est une adresse mémoire (On parle de référence) où se trouve tous
les renseignement concernant fr1 ou fr2 , en particulier les attributs.
C'et la même chose pour les types srtucturés comme les tableaux par exemple.

Deux autre méthodes sont crées à l'intérieur de la classe : affiche et mult qui permettent d'agir sur
un objet de type fraction.
L'appel à une méthode se fait par un point : objet.méthode(paramètres éventuels) ; par exemple fr1.affiche()
L'accès à la valeur d'un attribut se fait par un point : objet.attribut1 par exemple fr1.numerateur ou fr1.denominateur.

"""